#light

// This is the sequence function
let oddnumbers max = {1 .. 2 .. max}

// Just some helper code to see the entire sequence if desired
//let outputintseq seq = Seq.iter(fun item -> printf "%i " item) seq
//oddnumbers 10 |> outputintseq

// The calculation function based on fold (Reduce)
// This would be the place where automatic currying and partial application 
// would be great, but unfortunately it doesn't work here due to type
// inference restrictions. So a syntactic function (including the seq
// parameter) has to be created.
let sumcalculator seq = Seq.fold (fun r x -> r + x) 0 seq

// Composition used to combine the sequence and the calculator
let sumofoddnumbers max = oddnumbers max |> sumcalculator

// Done - test it
printfn "%i" (sumofoddnumbers 10)
read_line()

// Of course, in F# you probably wouldn't make so many steps:
let shortversion max = Seq.fold (fun r x -> r + x) 0 {1 .. 2 .. max}
printfn "%i" (shortversion 20)
read_line()
