Imports System.IO
Imports System.Reflection

Public Class DataSource

    Private productList As List(Of Product)
    Private customerList As List(Of Customer)
    Public Function GetProductList() As List(Of Product)
        If productList Is Nothing Then
            CreateLists()
        End If

        Return productList
    End Function

    Public Function GetCustomerList() As List(Of Customer)
        If customerList Is Nothing Then
            CreateLists()
        End If

        Return customerList
    End Function

    Private dataPath As String = System.Windows.Forms.Application.StartupPath & "\..\..\SampleData\"


    Private Sub CreateLists()
        ' Product data created in-memory using collection initializer:
        productList = _
            New List(Of Product) { _
                {ProductID := 1, ProductName := "Chai", Category := "Beverages", UnitPrice := 18.0, UnitsInStock := 39}, _
                        {ProductID := 2, ProductName := "Chang", Category := "Beverages", UnitPrice := 19.0, UnitsInStock := 17}, _
                            {ProductID := 3, ProductName := "Aniseed Syrup", Category := "Condiments", UnitPrice := 10.0, UnitsInStock := 13}, _
                            {ProductID := 4, ProductName := "Chef Anton's Cajun Seasoning", Category := "Condiments", UnitPrice := 22.0, UnitsInStock := 53}, _
                            {ProductID := 5, ProductName := "Chef Anton's Gumbo Mix", Category := "Condiments", UnitPrice := 21.35, UnitsInStock := 0}, _
                            {ProductID := 6, ProductName := "Grandma's Boysenberry Spread", Category := "Condiments", UnitPrice := 25.0, UnitsInStock := 120}, _
                            {ProductID := 7, ProductName := "Uncle Bob's Organic Dried Pears", Category := "Produce", UnitPrice := 30.0, UnitsInStock := 15}, _
                            {ProductID := 8, ProductName := "Northwoods Cranberry Sauce", Category := "Condiments", UnitPrice := 40.0, UnitsInStock := 6}, _
                            {ProductID := 9, ProductName := "Mishi Kobe Niku", Category := "Meat/Poultry", UnitPrice := 97.0, UnitsInStock := 29}, _
                            {ProductID := 10, ProductName := "Ikura", Category := "Seafood", UnitPrice := 31.0, UnitsInStock := 31}, _
                            {ProductID := 11, ProductName := "Queso Cabrales", Category := "Dairy Products", UnitPrice := 21.0, UnitsInStock := 22}, _
                            {ProductID := 12, ProductName := "Queso Manchego La Pastora", Category := "Dairy Products", UnitPrice := 38.0, UnitsInStock := 86}, _
                            {ProductID := 13, ProductName := "Konbu", Category := "Seafood", UnitPrice := 6.0, UnitsInStock := 24}, _
                            {ProductID := 14, ProductName := "Tofu", Category := "Produce", UnitPrice := 23.25, UnitsInStock := 35}, _
                            {ProductID := 15, ProductName := "Genen Shouyu", Category := "Condiments", UnitPrice := 15.5, UnitsInStock := 39}, _
                            {ProductID := 16, ProductName := "Pavlova", Category := "Confections", UnitPrice := 17.45, UnitsInStock := 29}, _
                            {ProductID := 17, ProductName := "Alice Mutton", Category := "Meat/Poultry", UnitPrice := 39.0, UnitsInStock := 0}, _
                            {ProductID := 18, ProductName := "Carnarvon Tigers", Category := "Seafood", UnitPrice := 62.5, UnitsInStock := 42}, _
                            {ProductID := 19, ProductName := "Teatime Chocolate Biscuits", Category := "Confections", UnitPrice := 9.2, UnitsInStock := 25}, _
                            {ProductID := 20, ProductName := "Sir Rodney's Marmalade", Category := "Confections", UnitPrice := 81.0, UnitsInStock := 40}, _
                            {ProductID := 21, ProductName := "Sir Rodney's Scones", Category := "Confections", UnitPrice := 10.0, UnitsInStock := 3}, _
                            {ProductID := 22, ProductName := "Gustaf's Knckebrd", Category := "Grains/Cereals", UnitPrice := 21.0, UnitsInStock := 104}, _
                            {ProductID := 23, ProductName := "Tunnbrd", Category := "Grains/Cereals", UnitPrice := 9.0, UnitsInStock := 61}, _
                            {ProductID := 24, ProductName := "Guaran Fantstica", Category := "Beverages", UnitPrice := 4.5, UnitsInStock := 20}, _
                            {ProductID := 25, ProductName := "NuNuCa Nu-Nougat-Creme", Category := "Confections", UnitPrice := 14.0, UnitsInStock := 76}, _
                            {ProductID := 26, ProductName := "Gumbr Gummibrchen", Category := "Confections", UnitPrice := 31.23, UnitsInStock := 15}, _
                            {ProductID := 27, ProductName := "Schoggi Schokolade", Category := "Confections", UnitPrice := 43.9, UnitsInStock := 49}, _
                            {ProductID := 28, ProductName := "Rssle Sauerkraut", Category := "Produce", UnitPrice := 45.6, UnitsInStock := 26}, _
                            {ProductID := 29, ProductName := "Thringer Rostbratwurst", Category := "Meat/Poultry", UnitPrice := 123.79, UnitsInStock := 0}, _
                            {ProductID := 30, ProductName := "Nord-Ost Matjeshering", Category := "Seafood", UnitPrice := 25.89, UnitsInStock := 10}, _
                            {ProductID := 31, ProductName := "Gorgonzola Telino", Category := "Dairy Products", UnitPrice := 12.5, UnitsInStock := 0}, _
                            {ProductID := 32, ProductName := "Mascarpone Fabioli", Category := "Dairy Products", UnitPrice := 32.0, UnitsInStock := 9}, _
                            {ProductID := 33, ProductName := "Geitost", Category := "Dairy Products", UnitPrice := 2.5, UnitsInStock := 112}, _
                            {ProductID := 34, ProductName := "Sasquatch Ale", Category := "Beverages", UnitPrice := 14.0, UnitsInStock := 111}, _
                            {ProductID := 35, ProductName := "Steeleye Stout", Category := "Beverages", UnitPrice := 18.0, UnitsInStock := 20}, _
                            {ProductID := 36, ProductName := "Inlagd Sill", Category := "Seafood", UnitPrice := 19.0, UnitsInStock := 112}, _
                            {ProductID := 37, ProductName := "Gravad lax", Category := "Seafood", UnitPrice := 26.0, UnitsInStock := 11}, _
                            {ProductID := 38, ProductName := "Cte de Blaye", Category := "Beverages", UnitPrice := 263.5, UnitsInStock := 17}, _
                            {ProductID := 39, ProductName := "Chartreuse verte", Category := "Beverages", UnitPrice := 18.0, UnitsInStock := 69}, _
                            {ProductID := 40, ProductName := "Boston Crab Meat", Category := "Seafood", UnitPrice := 18.4, UnitsInStock := 123}, _
                            {ProductID := 41, ProductName := "Jack's New England Clam Chowder", Category := "Seafood", UnitPrice := 9.65, UnitsInStock := 85}, _
                            {ProductID := 42, ProductName := "Singaporean Hokkien Fried Mee", Category := "Grains/Cereals", UnitPrice := 14.0, UnitsInStock := 26}, _
                            {ProductID := 43, ProductName := "Ipoh Coffee", Category := "Beverages", UnitPrice := 46.0, UnitsInStock := 17}, _
                            {ProductID := 44, ProductName := "Gula Malacca", Category := "Condiments", UnitPrice := 19.45, UnitsInStock := 27}, _
                            {ProductID := 45, ProductName := "Rogede sild", Category := "Seafood", UnitPrice := 9.5, UnitsInStock := 5}, _
                            {ProductID := 46, ProductName := "Spegesild", Category := "Seafood", UnitPrice := 12.0, UnitsInStock := 95}, _
                            {ProductID := 47, ProductName := "Zaanse koeken", Category := "Confections", UnitPrice := 9.5, UnitsInStock := 36}, _
                            {ProductID := 48, ProductName := "Chocolade", Category := "Confections", UnitPrice := 12.75, UnitsInStock := 15}, _
                            {ProductID := 49, ProductName := "Maxilaku", Category := "Confections", UnitPrice := 20.0, UnitsInStock := 10}, _
                            {ProductID := 50, ProductName := "Valkoinen suklaa", Category := "Confections", UnitPrice := 16.25, UnitsInStock := 65}, _
                            {ProductID := 51, ProductName := "Manjimup Dried Apples", Category := "Produce", UnitPrice := 53.0, UnitsInStock := 20}, _
                            {ProductID := 52, ProductName := "Filo Mix", Category := "Grains/Cereals", UnitPrice := 7.0, UnitsInStock := 38}, _
                            {ProductID := 53, ProductName := "Perth Pasties", Category := "Meat/Poultry", UnitPrice := 32.8, UnitsInStock := 0}, _
                            {ProductID := 54, ProductName := "Tourtire", Category := "Meat/Poultry", UnitPrice := 7.45, UnitsInStock := 21}, _
                            {ProductID := 55, ProductName := "Pt chinois", Category := "Meat/Poultry", UnitPrice := 24.0, UnitsInStock := 115}, _
                            {ProductID := 56, ProductName := "Gnocchi di nonna Alice", Category := "Grains/Cereals", UnitPrice := 38.0, UnitsInStock := 21}, _
                            {ProductID := 57, ProductName := "Ravioli Angelo", Category := "Grains/Cereals", UnitPrice := 19.5, UnitsInStock := 36}, _
                            {ProductID := 58, ProductName := "Escargots de Bourgogne", Category := "Seafood", UnitPrice := 13.25, UnitsInStock := 62}, _
                            {ProductID := 59, ProductName := "Raclette Courdavault", Category := "Dairy Products", UnitPrice := 55.0, UnitsInStock := 79}, _
                            {ProductID := 60, ProductName := "Camembert Pierrot", Category := "Dairy Products", UnitPrice := 34.0, UnitsInStock := 19}, _
                            {ProductID := 61, ProductName := "Sirop d'rable", Category := "Condiments", UnitPrice := 28.5, UnitsInStock := 113}, _
                            {ProductID := 62, ProductName := "Tarte au sucre", Category := "Confections", UnitPrice := 49.3, UnitsInStock := 17}, _
                            {ProductID := 63, ProductName := "Vegie-spread", Category := "Condiments", UnitPrice := 43.9, UnitsInStock := 24}, _
                            {ProductID := 64, ProductName := "Wimmers gute Semmelkndel", Category := "Grains/Cereals", UnitPrice := 33.25, UnitsInStock := 22}, _
                            {ProductID := 65, ProductName := "Louisiana Fiery Hot Pepper Sauce", Category := "Condiments", UnitPrice := 21.05, UnitsInStock := 76}, _
                            {ProductID := 66, ProductName := "Louisiana Hot Spiced Okra", Category := "Condiments", UnitPrice := 17.0, UnitsInStock := 4}, _
                            {ProductID := 67, ProductName := "Laughing Lumberjack Lager", Category := "Beverages", UnitPrice := 14.0, UnitsInStock := 52}, _
                            {ProductID := 68, ProductName := "Scottish Longbreads", Category := "Confections", UnitPrice := 12.5, UnitsInStock := 6}, _
                            {ProductID := 69, ProductName := "Gudbrandsdalsost", Category := "Dairy Products", UnitPrice := 36.0, UnitsInStock := 26}, _
                            {ProductID := 70, ProductName := "Outback Lager", Category := "Beverages", UnitPrice := 15.0, UnitsInStock := 15}, _
                            {ProductID := 71, ProductName := "Flotemysost", Category := "Dairy Products", UnitPrice := 21.5, UnitsInStock := 26}, _
                            {ProductID := 72, ProductName := "Mozzarella di Giovanni", Category := "Dairy Products", UnitPrice := 34.8, UnitsInStock := 14}, _
                            {ProductID := 73, ProductName := "Rd Kaviar", Category := "Seafood", UnitPrice := 15.0, UnitsInStock := 101}, _
                            {ProductID := 74, ProductName := "Longlife Tofu", Category := "Produce", UnitPrice := 10.0, UnitsInStock := 4}, _
                            {ProductID := 75, ProductName := "Rhnbru Klosterbier", Category := "Beverages", UnitPrice := 7.75, UnitsInStock := 125}, _
                            {ProductID := 76, ProductName := "Lakkalikri", Category := "Beverages", UnitPrice := 18.0, UnitsInStock := 57}, _
                            {ProductID := 77, ProductName := "Original Frankfurter grne Soe", Category := "Condiments", UnitPrice := 13.0, UnitsInStock := 32} _
                        }

        ' Customer/order data read into memory from XML file using XLinq:
        Dim customerListPath = Path.GetFullPath(Path.Combine(dataPath, "customers.xml"))

        Dim list = System.Xml.XLinq.XDocument.Load(customerListPath).Root.Elements("customer")

        customerList = (From e In list _
            Select New Customer { _
                CustomerID := CStr(e.<id>.Value), _
                CompanyName := CStr(e.<name>.Value), _
                Address := CStr(e.<address>.Value), _
                City := CStr(e.<city>.Value), _
                Region := CStr(e.<region>.Value), _
                PostalCode := CStr(e.<postalcode>.Value), _
                Country := CStr(e.<country>.Value), _
                Phone := CStr(e.<phone>.Value), _
                Fax := CStr(e.<fax>.Value), _
                Orders := ( _
                        From o In e...<orders>...<order> _
                Select New [Order] { _
                            OrderID := CInt(o.<id>.Value), _
                            OrderDate := CDate(o.<orderdate>.Value), _
                            Total := CDec(o.<total>.Value)}) _
                        .ToArray() _
                }).ToList()
    End Sub


End Class
