using System;
using System.Collections.Generic;
using System.Text;
using System.Data.DLinq;

namespace LINQToSQL
{
    //Note that we have not generated this from a DB but by hand
    //so you can see how domain first over SqlMetal works here

    //We are using attributes here to mark up the class.
    [Table(Name = "Customers")]
    public class Customer
    {
        #region Storage
        private EntitySet<Order> _Orders = new EntitySet<Order>();
        #endregion

        #region Public Fields
        [Column(Id = true)]
        public string CustomerID;
        [Column]
        public string CompanyName;
        [Column]
        public string ContactName;
        [Column]
        public string ContactTitle;
        [Column]
        public string Address;
        [Column]
        public string City;
        [Column]
        public string Region;
        [Column]
        public string PostalCode;
        [Column]
        public string Country;
        [Column]
        public string Phone;
        [Column]
        public string Fax;
        #endregion


        #region Properties
        //Orders table omitted for simplicity, so comment out association as it is missing
        //[Association(Name = "FK_Orders_Customers", Storage = "_Orders", OtherKey = "CustomerID")]
        public IList<Order> Orders
        {
            get
            {
                return _Orders;
            }
            set
            {
                _Orders.Assign(value);
            }
        }
        #endregion
    }



    //public class Customer
    //{
    //    #region Storage
    //    private EntitySet<Order> _Orders = new EntitySet<Order>();
    //    #endregion

    //    #region Public Fields
    //    public string CustomerID;
    //    public string CompanyName;
    //    public string ContactName;
    //    public string ContactTitle;
    //    public string Address;
    //    public string City;
    //    public string Region;
    //    public string PostalCode;
    //    public string Country;
    //    public string Phone;
    //    public string Fax;
    //    #endregion


    //    #region Properties
    //    public IList<Order> Orders
    //    {
    //        get
    //        {
    //            return _Orders;
    //        }
    //        set
    //        {
    //            _Orders.Assign(value);
    //        }
    //    }
    //    #endregion
    //}

}
