using System;
using System.Collections.Generic;
using System.Text;
using System.Data.DLinq;

namespace LINQToSQL
{
    public class Order
    {

        public int OrderID;
        public string CustomerID;
        public Nullable<int> EmployeeID;
        public Nullable<DateTime> OrderDate;
        public Nullable<DateTime> RequiredDate;
        public Nullable<DateTime> ShippedDate;
        public Nullable<int> ShipVia;
        public Nullable<decimal> Freight;
        public string ShipName;
        public string ShipAddress;
        public string ShipCity;
        public string ShipRegion;
        public string ShipPostalCode;
        public string ShipCountry;
        private EntityRef<Customer> _Customer;
        private EntitySet<OrderDetail> _OrderDetails;

        public Customer Customer
        {
            get
            {
                return this._Customer.Entity;
            }
            set
            {
                Customer v = _Customer.Entity;

                //if this is a new then reset the property
                if ((v != value))
                {
                    //if we are not nulling the value then
                    if ((v != null))
                    {
                        //remove us from the old customer's orders
                        _Customer.Entity = null;
                        v.Orders.Remove(this);
                    }

                    //set the customer
                    _Customer.Entity = value;

                    //if the customer was not null - add us to the customer's orders
                    if ((value != null))
                    {
                        value.Orders.Add(this);
                    }
                }
            }
        }

        public IList<OrderDetail> OrderDetails
        {
            get
            {
                return _OrderDetails;
            }
            set
            {
                _OrderDetails.Assign(value);
            }
        }
    }

}
