using System;
using System.Collections.Generic;
using System.Text;
using System.Linq;
using System.Data.Linq;

namespace LINQToSQL
{
    public class Product
    {

        public int ProductID;
        public string ProductName;
        public System.Nullable<int> SupplierID;
        public System.Nullable<int> CategoryID;
        public string QuantityPerUnit;
        public System.Nullable<decimal> UnitPrice;
        public System.Nullable<short> UnitsInStock;
        public System.Nullable<short> UnitsOnOrder;
        public System.Nullable<short> ReorderLevel;
        public bool Discontinued;

        private EntitySet<OrderDetail> _OrderDetails;
        private EntityRef<Supplier> _Supplier;

  
        public IList<OrderDetail> OrderDetails
        {
            get
            {
                return _OrderDetails;
            }
            set
            {
                _OrderDetails.Assign(value);
            }
        }

        public Supplier Supplier
        {
            get
            {
                return _Supplier.Entity;
            }
            set
            {
                Supplier v = _Supplier.Entity;
                if ((v != value))
                {
                    if ((v != null))
                    {
                        _Supplier.Entity = null;
                        v.Products.Remove(this);
                    }
                    _Supplier.Entity = value;
                    if ((value != null))
                    {
                        value.Products.Add(this);
                    }
                }
            }
        }
    }
}
